"use strict";const express=require("express"),bodyParser=require("body-parser"),logger=require("./logger"),http=require("http"),https=require("https"),async=require("async"),fs=require("fs"),request=require("request"),path=require("path"),Joi=require("joi"),uuid=require("uuid-random"),os=require("os"),url=require("url"),yaml_config=require("node-yaml-config");logger.logger.info("***************************************** STARTING *****************************************"),logger.logger.info("Loading napi, make sure all DLL files are in place");const nativeTest=require("./build/Release/native.node");logger.logger.info("napi: DONE"),logger.logger.info("Loading config, make sure config.yml has valid structure");var buildVersion=null,config=yaml_config.load(__dirname+"/config.yml");logger.logger.info("config: DONE");var currentRequests={};function setRequestProcessing(e,n){null!=currentRequests[e]&&null!=currentRequests[e].state?"success"!=currentRequests[e].state&&"error"!=currentRequests[e].state&&"cancelled"!=currentRequests[e].state&&(currentRequests[e].state="processing"):currentRequests[e]={ts:(new Date).getTime(),state:"processing",req:n}}function updateCurrentResponseObj(e,n){null!=currentRequests[e]&&(currentRequests[e].result=n)}function setRequestSuccess(e,n){null==currentRequests[e]&&(currentRequests[e]={ts:(new Date).getTime(),state:""}),currentRequests[e].state="success",currentRequests[e].result=n}function setRequestError(e,n,r){null==currentRequests[e]&&(currentRequests[e]={ts:(new Date).getTime(),state:"",message:""}),currentRequests[e].state="error",currentRequests[e].message=n,currentRequests[e].result=r}function setRequestCancelled(e,n){null!=currentRequests[e]&&null!=currentRequests[e].state?"error"!=currentRequests[e].state&&"success"!=currentRequests[e].state&&(currentRequests[e].state="cancelled",currentRequests[e].result=n):currentRequests[e]={ts:(new Date).getTime(),state:"cancelled"}}const app=express();app.use(bodyParser.json({limit:"80mb"})),app.use(function(e,n,r){n.header("Access-Control-Allow-Origin","*"),n.header("Access-Control-Allow-Headers","Origin, X-Requested-With, Content-Type, Accept"),r()});var api_definition={"/v1/license/check":{method:"get",func:(e,n)=>{processLicenseCheck(e,n)},description:"Pass ?json=true/false to change the output format",schema_resp:{ok:"bool: true/false",text:"string",validTo:"string",licenseTo:"string",expired:"bool: true/false"}},"/v1/license/upgrade":{method:"post",func:(e,n)=>{processLicenseUpgrade(e,n)},schema_resp:{ok:"bool: true/false",text:"string",validTo:"string",licenseTo:"string",expired:"bool: true/false"}},"/v1/ingenico_status":{method:"get",func:(e,n)=>{processIngenicoStatus(e,n)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",transactionStatus:"number: (0x00 - 0x81) 0x00 - Idle, 0x01 - WaitCard, 0x02 - WaitPIN, 0x03 - WaitEMVApp, 0x04 - WaitHost, 0x05 - WaitSign, 0x06 - WaitTrEnd, 0x07 - WaitNoCard, 0x08 - WaitBusy, 0x09 - InProgress, 0x0A - WaitCopy, 0x0B - WaitAuthCode, 0x0C - WaitAction, 0x0D - BatchCompleted, 0x0E - DCCCurrency, 0x0F - CashBackAmount, 0x10 - Used internaly, 0x11 - Used internaly, 0x12 - Transaction accepted, 0x13 - Used internaly, 0x14 - Waiting for amount, 0x15 - Waiting for selection, 0x16 - Asking ECR to print data, 0x17 - Presenting ZenCard offer, 0x18 - Waiting for fid, 0x19 - Asking ECR to receive data, 0x20 - Asking ECR to provide data, 0x21 - Zencard continue, 0x80 - Application in error state, 0x81 - Reconciliation needed ",sequenceNb:""}}},"/v1/ingenico_general_info":{method:"get",func:(e,n)=>{processIngenicoGeneralInfo(e,n)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",terminalInfo:"string - comma separated data"}}},"/v1/ingenico_async_transaction_process":{method:"post",func:(e,n)=>{processIngenicoTransactionAuto(e,n)},schema:Joi.object().keys({type:Joi.string().required().valid("purchase","preauthorization","completion","preauthorization_cancel","refund","reversal","giftcard_activation","giftcard_balance","giftcard_topup","reconciliation","connection_test","tms"),amount:Joi.number().required(),title:Joi.string(),sequenceNb:Joi.string(),callback:Joi.object().keys({uri:Joi.string().required(),method:Joi.string().required().valid("POST","GET","PUT")}),posnetserver:Joi.object()}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",uuid:"string"},description:'Use posnetserver structure when integration with PosnetServer is enabled (config.posnetserver.active=true). Sample JSON object: {"lines": [{ "na": "Towar 1", "il": 1.0, "vtp": "23,00", "pr": 2350 },{ "na": "Towar 2", "il": 1.0, "vtp": "23,00", "pr": 1150 }], "summary": { "to": 3500 } }. PosnetServer documentation can be found here: https://blog.bigdotsoftware.pl/posnet-server-wydruk-paragonu/'},"/v1/ingenico_async_transaction_cancel/:uuid":{method:"post",func:(e,n)=>{processIngenicoTransactionCancel(e,n)},description:"Method markes request as cancelled and releases COM port. Transaction still have to be manually cancelled from terminal's keyboard",schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",uuid:"string"}},"/v1/ingenico_async_transaction_status/:uuid":{method:"get",func:(e,n)=>{processIngenicoTransactionStatus(e,n)},schema_resp:{watermark:"string",ts:"long",state:"string: success, error, cancelled, processing",req:"object",result:"object"}},"/v1/ingenico_async_transaction_statuses":{method:"get",func:(e,n)=>{processIngenicoTransactionStatuses(e,n)},schema_resp:{watermark:"string","{uuid}":{ts:"long",state:"string: success, error, cancelled, processing",req:"object",result:"object"}}},"/v1/ingenico_transaction":{method:"post",func:(e,n)=>{processIngenicoTransactionStart(e,n)},schema:Joi.object().keys({type:Joi.string().required().valid("purchase","preauthorization","completion","preauthorization_cancel","refund","reversal","giftcard_activation","giftcard_balance","giftcard_topup","reconciliation","connection_test","tms"),amount:Joi.number().required(),title:Joi.string(),sequenceNb:Joi.string().required(),arguments:Joi.object().keys({transactionFlags:Joi.array().items(Joi.string().valid("TokenGeneration","ReferenceNumberGeneration","TransitTransactionIndicator")),blikCode:Joi.number(),additionalPrintout:Joi.string(),hints:Joi.string(),rfu:Joi.string(),variableSymbol:Joi.string(),specificSymbol:Joi.string(),saleItemList:Joi.object().keys({itemId:Joi.string(),productCode:Joi.string(),amount:Joi.number(),unitMeasure:Joi.string(),unitPrice:Joi.number(),quantity:Joi.number(),taxCode:Joi.string()})})}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"},description:"sequenceNb is mandatory but for completion and reversal types only. Set it to '-' for other types"},"/v1/ingenico_transaction_end":{method:"get",func:(e,n)=>{processIngenicoTransactionEnd(e,n)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",transactionType:"number",transactionResultCode:"number",transactionResultCodeText:"string",transactionNumber:"number",transactionDetails:{authorizationCode:"string",serverMessage:"string",merchantID:"string: example '454500000000000'",maskedCardNumber:"string: example '************0211'",date:"string: example format 2021.01.25",time:"string: example format 12:59:32",cardsetName:"string: example 'VISA'",readerUsed:"string: example 'C' - possible values: B Contactless, M Manual, C Magstripe, P ICC, ? Unknown",readerUsedText:"string: possible values 'magstripe', 'contactless', 'manual', 'icc', 'unknown'",terminalIdentifier:"string: example '45450318'",authorizationMessage:"string: example '000180'",authorizationType:"string: possible values 1 - online, 3 – offline, 4 – referral",authorizationTypeText:"string: possible values 'online', 'offline', 'referral'",transactionAmount:"string",cardholderAuthorizationMethod:"string: possible values A – PIN, @ - Signature, B – PIN and Signature, ? – no authorization",cardholderAuthorizationMethodText:"string: possible values 'pin', 'signature', 'pin_signature', 'no authorization', 'unknown'",atc:"string",ac:"string",aid:"string",tvr:"string",tsi:"string",title:"string",printingIndicator:"string: example '1'",transactionCurrency:"string: example 'PLN'",terminalCurrency:"string",exchangeRate:"string",dcc1:"string",dcc2:"string",cashAmount:"string",spendingAmount:"string",dcc_currencyExp:"string",additionalInformation:"string: example 'DF060A534E204E722056697361DF0B0400000100' or 'DF0B0400000100' or 'DF060A534E204E722056697361DF0B0400000400DF1318343534353033313830303031323630313231323132383534'",additionalInformationObject:"object"},error:"string"}}},"/v1/ingenico_batch_recon_data/:transactionIndex":{method:"get",func:(e,n)=>{processIngenicoTransactionReconData(e,n)}},"/v1/ingenico_batch_recon_info":{method:"get",func:(e,n)=>{processIngenicoTransactionReconInfo(e,n)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",error:"string",results:"[] array"}}},"/v1/ingenico_transaction_data_input":{method:"post",func:(e,n)=>{processIngenicoTransactionDataInput(e,n)},schema:Joi.object().keys({text:Joi.string().required(),sequenceNb:Joi.string().required()}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"}},"/v1/ingenico_report_generate":{method:"post",func:(e,n)=>{processIngenicoTransactionReportGenerate(e,n)}},"/v1/ingenico_report_summary/:cardset":{method:"get",func:(e,n)=>{processIngenicoTransactionGetSummary(e,n)}},"/v1/ingenico_report_total_summary":{method:"get",func:(e,n)=>{processIngenicoTransactionGetTotalSummary(e,n)}},"/":{method:"get",func:(e,n)=>{processRootRestApi(e,n)}}};function convertToSampleJSON(e){var n={};return null!=e.$_terms.keys&&e.$_terms.keys.forEach(e=>{if("object"==e.schema.type){var r=JSON.stringify(convertToSampleJSON(e.schema));n[e.key]=r}else if(n[e.key]=e.schema.type,null!=e.schema._valids&&null!=e.schema._valids._values){n[e.key]+=": ";const r=[...e.schema._valids._values];n[e.key]+=r.join(", ")}}),n}function getProtocol(e){var n=e.connection.encrypted?"https":"http";return(n=e.headers["x-forwarded-proto"]||n).split(/\s*,\s*/)[0]}function GetWatermarkString(){var e=CheckLicense();if(e.ok){var n=readStatInfo(e);return"Wersja licencjonowana dla "+n.licenseTo+" ważna do "+new Date(1e3*n.validTo).toISOString()}return"Wersja nielicencjonowana"+(""!=config.license.file?" lub przeznaczona dla innego produktu":"")+". W wersji nielicencjonowanej do kwoty na terminalu dodawane są losowe grosze"}function initOtherOptions(e){buildVersion=e.buildVersion}function isFullDebugMode(e){return null!=e&&(null!=e.query&&(null!=e.query.fulldebug&&("false"!=e.query.fulldebug&&"true"==e.query.fulldebug)))}function isResetFlagEnabled(e){return null!=e&&(null!=e.query&&(null!=e.query.reset&&("false"!=e.query.reset&&"true"==e.query.reset)))}function initApiDefinitions(e){for(const[n,r]of Object.entries(e))"get"==r.method?app.get(n,r.func):"put"==r.method?app.put(n,r.func):"post"==r.method?app.post(n,r.func):"delete"==r.method?app.delete(n,r.func):logger.logger.error("Unrecognized method: "+r.method)}function initHiddenApiDefinitions(){app.get("/v1/tests/run",(e,n)=>{processRunTests(e,n)})}function processRootRestApi(e,n){var r=[{groupname:"General information"},{type:"GET",name:""},{groupname:"IngenicoServer methods (summary)"}];for(const[e,n]of Object.entries(api_definition))"/"!=e&&0==e.startsWith("/async_queue")&&r.push({type:n.method.toUpperCase(),name:e.substr(1)});if(r.push({groupname:"IngenicoServer methods (details)"}),e.query.textdetails)for(const[e,n]of Object.entries(api_definition))"/"!=e&&0==e.startsWith("/async_queue")&&r.push({type:n.method.toUpperCase(),name:e.substr(1),schema:n.schema,schema_resp:n.schema_resp,description:n.description});var t="";r.forEach(n=>{null!=n.groupname?t+="<br>\n<b>"+n.groupname+"</b><br>\n":null!=n.ref?(t+=api_definition[n.ref].method.toUpperCase().padEnd(6," ").replace(/ /g,"&nbsp;")+" "+getProtocol(e)+"://"+e.headers.host+"/"+n.ref.substr(1)+"  <br>\n",null!=api_definition[n.ref].attributes&&api_definition[n.ref].attributes.length>0&&api_definition[n.ref].attributes.forEach(e=>{t+="       ".replace(/ /g,"&nbsp;")+" ?"+e.attribute+" = "+e.description+" (default: "+e.default+")  <br>\n"})):(t+=n.type.padEnd(6," ").replace(/ /g,"&nbsp;")+" "+getProtocol(e)+"://"+e.headers.host+"/"+n.name+"  <br>\n",n.schema&&(t+="Request:<br>\n"+prettyJson(convertToSampleJSON(n.schema)).replace(/\t/g,"<br>")+"  <br>\n"),n.schema_resp&&(t+="Response:<br>\n"+prettyJson(n.schema_resp).replace(/\t/g,"<br>")+"  <br>\n"),n.description&&(t+="Description:<br>\n"+n.description+"  <br>\n"),(n.schema||n.schema_resp)&&(t+="  <hr>\n"))}),e.query.textdetails||(t+='<br>\n<a href="/?textdetails=true">Show</a><br>\n'),n.send("<tt>\nIngenico Server v."+buildVersion+' © 2021 BigDotSoftware (bigdotsoftware@bigdotsoftware.pl). <br>\nHow to start: https://blog.bigdotsoftware.pl/ingenico-server-pierwsze-uzycie/ <br>\n<br>\nSwagger YAML: &nbsp; <a href="https://github.com/bigdotsoftware/ingenicoserver/blob/main/swagger/swagger-1.2.yaml">https://github.com/bigdotsoftware/ingenicoserver/blob/main/swagger/swagger-1.2.yaml</a> <br>\n<br>\nSwagger Editor: <a href="https://editor.swagger.io/?url=https://download2.bigdotsoftware.pl/github_ingenico_swagger/swagger-1.2.yaml">Open in Editor</a> <br>\n<br>\nRESTful API: <br></tt><tt>\n'+t+"</tt>")}function replaceAll(e,n,r){return e.split(n).join(r)}function ConnectionBegin(e,n){var r=isFullDebugMode(e);nativeTest.PosnetIsConnected().ok?n({ok:!1,error:"Already connected - check connect sequence or another transaction is in progress"}):(r&&console.log("FULLDEBUG: Preparing connection to the printer"),n(ConnectionBeginProcess(e)))}function ConnectionBeginProcess(e){var n=isFullDebugMode(e),r=null;if("rs232"==config.ingenico.connection.type){n&&console.log("FULLDEBUG: Opening COM port "+config.ingenico.connection.rs232.params);const e=null!=config.ingenico.connection.rs232.disable_ioctl&&config.ingenico.connection.rs232.disable_ioctl;r=nativeTest.PosnetConnectRS232(config.ingenico.connection.rs232.params,n?"1":"0",e?"1":"0"),n&&console.log("FULLDEBUG: Opening COM port result"+JSON.stringify(r))}else"eth"==config.ingenico.connection.type&&(n&&console.log("FULLDEBUG: Opening Socket "+config.ingenico.connection.eth.ip+":"+config.ingenico.connection.eth.port),r=nativeTest.PosnetConnectEth(config.ingenico.connection.eth.ip,config.ingenico.connection.eth.port,n?"1":"0"));return null==r||0==r.ok?(logger.logger.error(JSON.stringify(r)),null==r?{ok:!1,error:"Unknown error"}:r):r}function ConnectionEnd(){var e=nativeTest.PosnetDisconnect();return e.ok||logger.logger.error(JSON.stringify(e)),e}function readStatInfo(e){var n="",r=0,t=!0;return e.results.forEach(e=>{null!=e.licenseTo&&""!=e.licenseTo&&(n=e.licenseTo),null!=e.validTo&&""!=e.validTo&&(r=e.validTo),null!=e.expired&&""!=e.expired&&(t="false"!=e.expired)}),{licenseTo:n,validTo:r,expired:t}}function obtainNewLicenseFile(e){var n="https://license.bigdotsoftware.pl/obtain/"+e;logger.logger.debug(n),request({url:n,method:"POST",rejectUnauthorized:!1,strictSSL:!1,encoding:null,json:{action:"renew"}},(e,n,r)=>{if(logger.logger.info("statusCode:",n&&n.statusCode),e)logger.logger.info("cannot execute license endpoint: "+e);else if(n&&200!=n.statusCode)logger.logger.error("cannot execute license endpoint, statusCode: "+n.statusCode);else{logger.logger.info("license endpoint executed ok");var t=config.license.file+"."+(new Date).getTime()+".backup";logger.logger.info("license endpoint copy as "+t),fs.copyFile(config.license.file,t,e=>{if(e)logger.logger.error("error "+e);else{logger.logger.info("copied as "+t),fs.writeFileSync(config.license.file+".new",r,"binary"),logger.logger.info("validating "+config.license.file+".new");var n=nativeTest.ValidateLicenseFile({file:config.license.file+".new",skipcache:1});if(logger.logger.info("validated"+JSON.stringify(n)),n.ok){logger.logger.info("downloaded file is valid license file");var o=readStatInfo(n);logger.logger.debug(o),o.expired?logger.logger.warn("... but expired"):(logger.logger.info("replacing license file...."),fs.copyFile(config.license.file+".new",config.license.file,e=>{e?logger.logger.error("error replacing license file: "+e):logger.logger.info("license file replaced")}))}else logger.logger.error("downloaded file is not valid license file")}})}})}function processLicenseUpgrade(e,n){setTimeout(function(){if(null==config.license.file||""==config.license.file)return sendErrorResponse(e,n,"Wersja nielicencjonowana");logger.logger.info("license file: "+config.license.file);var r=nativeTest.ValidateLicenseFile({file:config.license.file});if(logger.logger.info(JSON.stringify(r)),null!=r.results){var t="";if(r.results.forEach(e=>{null!=e.uniqueLicenseId&&""!=e.uniqueLicenseId&&(t=e.uniqueLicenseId)}),""!=t?obtainNewLicenseFile(t):logger.logger.error("Cannot determine unique license ID"),r.ok){var o=readStatInfo(r);return sendResponse(e,n,{ok:!0,text:"Wersja licencjonowana dla "+o.licenseTo+" ważna do "+new Date(1e3*o.validTo).toISOString(),validTo:o.validTo,licenseTo:o.licenseTo,expired:o.expired,requested:!0,requestedtext:"Requested for new license file. Check logs for more details"})}return sendErrorResponse(e,n,"Wersja nielicencjonowana")}},500)}function processLicenseCheck(e,n){setTimeout(function(){var r=CheckLicense();if(r.ok){var t=readStatInfo(r);return e.query.json?sendResponse(e,n,{ok:!0,text:"Wersja licencjonowana dla "+t.licenseTo+" ważna do "+new Date(1e3*t.validTo).toISOString(),validTo:t.validTo,licenseTo:t.licenseTo,expired:t.expired}):sendResponse(e,n,"Wersja licencjonowana dla "+t.licenseTo+" ważna do "+new Date(1e3*t.validTo).toISOString())}return e.query.json?sendErrorResponse(e,n,{ok:!1,text:"Wersja nielicencjonowana",expired:!0}):sendErrorResponse(e,n,"Wersja nielicencjonowana")},500)}function processRunTests(e,n){var r=isFullDebugMode(e);return sendResponse(e,n,nativeTest.RunTests(r?"1":"0"))}function processIngenicoStatus(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=nativeTest.GetTermInfo(r?"1":"0");var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)})}function processIngenicoGeneralInfo(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=nativeTest.GetTermGeneralInfo(r?"1":"0");var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)})}function verifyTermResponse(e,n,r,t){if(0!=r.terminal.returnCode){null!=n&&sendErrorResponse(e,n,r);ConnectionEnd();return null!=t&&setRequestError(t,r.error,r),!1}return!0}function processIngenicoTransactionReconData(e,n){var r=isFullDebugMode(e);const t=e.params.transactionIndex;ConnectionBegin(e,o=>{if(!o.ok)return void sendErrorResponse(e,n,o);const i=nativeTest.TransactionReconData(r?"1":"0",{transactionIndex:t});if(verifyTermResponse(e,n,i)){var s=ConnectionEnd();return s.ok?sendResponse(e,n,i):sendErrorResponse(e,n,s)}})}function processIngenicoTransactionReconInfo(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=nativeTest.TransactionReconInfo(r?"1":"0");if(verifyTermResponse(e,n,o)){var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)}})}function processIngenicoTransactionDataInput(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=nativeTest.TransactionDataInput(r?"1":"0");if(verifyTermResponse(e,n,o)){var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)}})}function processIngenicoTransactionReportGenerate(e,n){var r=isFullDebugMode(e),t=isResetFlagEnabled(e);ConnectionBegin(e,o=>{if(!o.ok)return void sendErrorResponse(e,n,o);const i=nativeTest.TransactionReportGenerate(r?"1":"0",{reset:t?"1":"0"});if(verifyTermResponse(e,n,i)){var s=ConnectionEnd();return s.ok?sendResponse(e,n,i):sendErrorResponse(e,n,s)}})}function processIngenicoTransactionGetSummary(e,n){var r=isFullDebugMode(e);const t=e.params.cardset;ConnectionBegin(e,o=>{if(!o.ok)return void sendErrorResponse(e,n,o);const i=nativeTest.TransactionReportGetSummary(r?"1":"0",{cardset:t});if(verifyTermResponse(e,n,i)){var s=ConnectionEnd();return s.ok?sendResponse(e,n,i):sendErrorResponse(e,n,s)}})}function processIngenicoTransactionGetTotalSummary(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=nativeTest.TransactionReportGetTotalSummary(r?"1":"0");if(verifyTermResponse(e,n,o)){var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)}})}function ClearBatchCompleted(e,n,r){for(var t=0;t<100;t++){if(!verifyTermResponse(e,n,nativeTest.TransactionReconInfo(r?"1":"0")))return!1;var o=nativeTest.GetTermInfo(r?"1":"0");if(!verifyTermResponse(e,n,o))return!1;if(0==o.terminal.transactionStatus)break}return!0}function processIngenicoTransactionEnd(e,n){var r=isFullDebugMode(e);ConnectionBegin(e,t=>{if(t.ok){var o=nativeTest.TransactionEnd(r?"1":"0");if(verifyTermResponse(e,n,o)){logger.logger.info("trEnd done: "+JSON.stringify(o));var i=ConnectionEnd();return i.ok?sendResponse(e,n,o):sendErrorResponse(e,n,i)}}else sendErrorResponse(e,n,t)})}function sleep(e){return new Promise(n=>{setTimeout(n,e)})}function getSchemaForRequest(e){let n=url.parse(e.url);return null!=api_definition[n.pathname]?api_definition[n.pathname].schema:null}function validateSchema(e,n){var r=getSchemaForRequest(e);if(null!=r){var t=r.validate(e.body);return null==t.error||(logger.logger.warn("Payload validation error:"+JSON.stringify(t)),sendErrorResponse(e,n,t.error),!1)}return!0}function processIngenicoTransactionCancel(e,n){var r=e.params.uuid;return null!=currentRequests[r]?(logger.logger.info(`Marking request ${r} cancelled`),setRequestCancelled(r,{ok:!1}),sendResponse(e,n,currentRequests[r])):sendErrorResponse(e,n,"Wrong UUID")}function processIngenicoTransactionStatus(e,n){return null!=currentRequests[e.params.uuid]?sendResponse(e,n,currentRequests[e.params.uuid]):sendErrorResponse(e,n,"Wrong UUID")}function processIngenicoTransactionStatuses(e,n){return sendResponse(e,n,currentRequests)}function processIngenicoTransactionAuto(e,n){var r=isFullDebugMode(e);validateSchema(e,n)&&ConnectionBegin(e,async t=>{if(!t.ok)return void sendErrorResponse(e,n,t);const o=uuid();setRequestProcessing(o,e.body);var i=nativeTest.GetTermInfo(r?"1":"0");if(!verifyTermResponse(e,n,i,o))return;if(logger.logger.info("trStatus done: "+JSON.stringify(i)),129==i.terminal.transactionStatus){const t=nativeTest.TransactionBegin(r?"1":"0",{type:"reconciliation",amount:0,title:"",sequenceNb:"",arguments:{},file:GetLicenseFile()});if(logger.logger.info("trReconciliation done: "+JSON.stringify(t)),!verifyTermResponse(e,n,t,o))return;i=await startListeningForWaitTrEnd(e,n,r,o);var s=nativeTest.TransactionEnd(r?"1":"0");if(!verifyTermResponse(e,n,s,o))return;if(logger.logger.info("trEnd done: "+JSON.stringify(s)),i=nativeTest.GetTermInfo(r?"1":"0"),!verifyTermResponse(e,n,i,o))return;logger.logger.info("trStatus done: "+JSON.stringify(i))}if(13==i.terminal.transactionStatus&&!ClearBatchCompleted(e,n,r))return void ConnectionEnd();if(1==i.terminal.transactionStatus)return logger.logger.warn("Cannot interrupt transaction in WAIT_CARD state"),ConnectionEnd(),void sendErrorResponse(e,n,{ok:!1,error:i.terminal.transactionStatusText+" : Przyłuż kartę lub anuluj na terminalu rozpoczętą transakcję"});if(6==i.terminal.transactionStatus){logger.logger.info("Interrupting current transaction in WAIT_TREND state");s=nativeTest.TransactionEnd(r?"1":"0");if(!verifyTermResponse(e,n,s,o))return;if(logger.logger.info("trEnd done: "+JSON.stringify(s)),i=nativeTest.GetTermInfo(r?"1":"0"),!verifyTermResponse(e,n,i,o))return;logger.logger.info("trStatus done: "+JSON.stringify(i))}const a=nativeTest.TransactionBegin(r?"1":"0",{type:e.body.type,amount:null!=e.body.amount?e.body.amount:0,title:null!=e.body.title?e.body.title:"",sequenceNb:null!=e.body.sequenceNb?e.body.sequenceNb:"",arguments:null!=e.body.arguments?e.body.arguments:{},file:GetLicenseFile()});if(logger.logger.info("trBegin done: "+JSON.stringify(a)),verifyTermResponse(e,n,a,o)){if(a.ok?sendResponse(e,n,{ok:!0,uuid:o}):sendErrorResponse(e,n,a),6!=(i=await startListeningForWaitTrEnd(e,null,r,o)).terminal.transactionStatus)return logger.logger.info("Interrupting due to wrong status: "+JSON.stringify(i)),void ConnectionEnd();s=nativeTest.TransactionEnd(r?"1":"0");if(verifyTermResponse(e,null,s,o)){logger.logger.info("trEnd done: "+JSON.stringify(s)),0==s.terminal.transactionResultCode?setRequestSuccess(o,s):1==s.terminal.transactionResultCode||7==s.terminal.transactionResultCode?setRequestCancelled(o,s):setRequestError(o,"",s),e.body.callback&&notifyBackendAboutTransactionResult(s,e.body.callback),config.posnetserver.active&&(e.body.posnetserver?0==s.terminal.transactionResultCode?sendToPosnetServer(e.body.posnetserver):logger.logger.warn("Integracja z PosnetServer jest włączona, transakcja na terminalu nie zakonczyla sie sukcesem - paragon nie bedzie drukowany"):logger.logger.warn("Integracja z PosnetServer jest włączona, ale request nie zawiera struktury 'posnetserver' którą można przekazać do serwisu."));var c=ConnectionEnd();c.ok||logger.logger.error("cannot end: "+JSON.stringify(c))}}})}function sendToPosnetServer(e){logger.logger.warn("Integracja z PosnetServer : "+JSON.stringify(e)),ExecuteUrl(config.posnetserver.url+"/paragon","POST",e)}function ExecuteUrl(e,n,r){const t=(new Date).getTime();async.retry({times:config.ingenico.retry.times,interval:config.ingenico.retry.interval},function(t){request({url:e,method:n,rejectUnauthorized:!1,strictSSL:!1,json:r},(n,r,o)=>{n?(logger.logger.error("Cannot execute url: "+e+" : "+n),t(!0)):(logger.logger.debug(`URL ${e} executed OK`),t(!1,{}))})},function(e,n){logger.logger.debug("ExecuteUrl is Done");const r=(new Date).getTime()-t;e?logger.logger.error(`ExecuteUrl failed in ${r} ms : ${e}`):logger.logger.info(`ExecuteUrl succeeded ${r} ms`)})}function notifyBackendAboutTransactionResult(e,n){ExecuteUrl(n.uri,n.method,JSON.stringify(e))}async function startListeningForWaitTrEnd(e,n,r,t){var o=nativeTest.GetTermInfo(r?"1":"0");if(updateCurrentResponseObj(t,o),!verifyTermResponse(e,n,o))return o;for(logger.logger.info("trStatus done: "+JSON.stringify(o));6!=o.terminal.transactionStatus;){if(updateCurrentResponseObj(t,o=nativeTest.GetTermInfo(r?"1":"0")),!verifyTermResponse(e,n,o))return o;if(logger.logger.info("trStatus done: "+JSON.stringify(o)),null!=currentRequests[t]&&"cancelled"==currentRequests[t].state)return logger.logger.info(`Received cancelled flag for ${t}`),o;await sleep(1e3)}return o}function processIngenicoTransactionStart(e,n){var r=isFullDebugMode(e);validateSchema(e,n)&&ConnectionBegin(e,t=>{if(!t.ok)return void sendErrorResponse(e,n,t);var o=nativeTest.GetTermInfo(r?"1":"0");if(!verifyTermResponse(e,n,o))return;if((logger.logger.info("trStatus done: "+JSON.stringify(o)),13==o.terminal.transactionStatus)&&!ClearBatchCompleted(e,n,r))return void ConnectionEnd();if(1==o.terminal.transactionStatus)return ConnectionEnd(),void sendErrorResponse(e,n,{ok:!1,error:o.terminal.transactionStatusText+" : Przyłuż kartę lub zamknij rozpoczętą transakcję"});if(6==o.terminal.transactionStatus)return ConnectionEnd(),void sendErrorResponse(e,n,{ok:!1,error:o.terminal.transactionStatusText+" : Zamknij niedokończoną transakcję"});logger.logger.info("TransactionBegin - preparing");const i=nativeTest.TransactionBegin(r?"1":"0",{type:e.body.type,amount:null!=e.body.amount?e.body.amount:0,title:null!=e.body.title?e.body.title:"",sequenceNb:null!=e.body.sequenceNb?e.body.sequenceNb:"",arguments:null!=e.body.arguments?e.body.arguments:{},file:GetLicenseFile()});if(logger.logger.info("trBegin done: "+JSON.stringify(i)),verifyTermResponse(e,n,i)){var s=ConnectionEnd();return s.ok?sendResponse(e,n,{ok:!0}):sendErrorResponse(e,n,s)}})}function isPrettyOutput(e){return null!=e.query&&e.query.pretty}function prettyJson(e){return"<tt>"+JSON.stringify(e,null,2).replace(/\n/g,"<br/>").replace(/ /g,"&nbsp;")+"</tt>"}function sendErrorResponse(e,n,r){var t=GetWatermarkString();return r===Object(r)&&(r.watermark=t),isPrettyOutput(e)?n.send(prettyJson(r)):n.json(r)}function sendResponse(e,n,r){var t=GetWatermarkString();return r===Object(r)&&(r.watermark=t),isPrettyOutput(e)?n.send(prettyJson(r)):n.json(r)}function initNative(){var e=null!=config.ingenico.commanddelay?config.ingenico.commanddelay:200,n=null!=config.ingenico.waitdelay?config.ingenico.waitdelay:100,r=null!=config.ingenico.commandresponsetimeout?config.ingenico.commandresponsetimeout:1e4,t=null!=config.ingenico.responsewaitdelay?config.ingenico.responsewaitdelay:100;logger.logger.info("Initializing ingenico module"),nativeTest.InitializeModule({loggernative:config.logger.native,licensefile:GetLicenseFile(),commanddelay:e,waitdelay:n,responsewaitdelay:t,commandresponsetimeout:r})}function initScheduleQueueCleaner(){logger.logger.info(`Scheduling queue cleaner with retention of ${config.queue.retention} ms`),setInterval(function(){const e=(new Date).getTime(),n=config.queue.retention;var r={};for(const[o,i]of Object.entries(currentRequests)){if(i.ts+n<e&&"processing"!=i.state){var t=JSON.stringify(i);logger.logger.debug(`Removing expired ${o} from the queue -> ${t}`)}else r[o]=i}currentRequests=r},2e3)}function initPinger(){config.ingenico.ping.active?(logger.logger.info(`Scheduling pinger with interval ${config.ingenico.ping.interval} ms`),setInterval(function(){ConnectionBegin(null,e=>{if(!e.ok)return void logger.logger.error("PING|Port open error: "+JSON.stringify(e));const n=nativeTest.GetTermInfo("0");var r=null!=n.terminal.transactionStatusText?n.terminal.transactionStatusText:"";logger.logger.info(`PING|status: ${n.terminal.transactionStatus} with text: '${r}'`);var t=ConnectionEnd();t.ok||logger.logger.error("PING|Port close error: "+JSON.stringify(t))})},config.ingenico.ping.interval)):logger.logger.info("Pinger is disabled in configuration. To enable it set ingenico.ping.active=true")}function initLicense(){return logger.logger.info(`Checking license file ${GetLicenseFile()} .....`),CheckLicense()}function init(e,n,r){initApiDefinitions(api_definition),initHiddenApiDefinitions(),initOtherOptions(r),initScheduleQueueCleaner(),logger.logger.info(`Trying to open HTTP on port: ${e.port}`);try{var t=http.createServer(app);t.on("error",function(n){logger.logger.error(`Cannot start HTTP at http://localhost: ${e.port}, please check if there no another process listening on the same port. Reason: ${n}`)}),t.listen(e.port),logger.logger.info("HTTP  at http://localhost:"+e.port)}catch(n){logger.logger.error(`Cannot start HTTP at http://localhost:' ${e.port}, please check if there no another process listening on the same port. Reason: ${n}`)}if(n.active){logger.logger.info(`Loading SSL certs...: ${n.sslcertificates.key}`);var o=null;try{o={key:fs.readFileSync(n.sslcertificates.key),cert:fs.readFileSync(n.sslcertificates.crt)}}catch(e){logger.logger.error(`Cannot load certificates ${n.sslcertificates.key} and ${n.sslcertificates.crt}. Reason: ${e}`)}if(null!=o){logger.logger.info(`Trying to open HTTPS on port: ${n.port}`);try{https.createServer(o,app).listen(n.port),logger.logger.info(`HTTPS at https://localhost: ${n.port}`)}catch(e){logger.logger.error(`Cannot start HTTPS at https://localhost: ${n.port}, please check your certificate under the ./cert directory. Reason: ${e}`)}}}else logger.logger.info("HTTPS is disabled in configuration. To enable set https.active=true in config.yml");initNative(),initPinger(),initLicense()}function GetLicenseFile(){return config.license.file}function CheckLicense(){var e={ok:!1};if(null==config.license.file||""==config.license.file)logger.logger.warn("No license file provided. Amount on terminal in unregistered version is randomly increased by PLN grosze."),logger.logger.warn("Brak pliku licencji. W wersji nielicencjonowanej do kwoty na terminalu dodawane są losowe grosze.");else if(null!=config.license.file&&""!=config.license.file&&(logger.logger.info("license file: "+config.license.file),e=nativeTest.ValidateLicenseFile({file:config.license.file}),logger.logger.info(JSON.stringify(e)),e.ok||(logger.logger.warn("Wrong license file provided. Amount on terminal in unregistered version is randomly increased by PLN grosze."),logger.logger.warn("Błędny plik licencji. W wersji nielicencjonowanej do kwoty na terminalu dodawane są losowe grosze.")),null!=e.results)){var n="",r=999;e.results.forEach(e=>{if(null!=e.validTo&&""!=e.validTo){var t=parseInt(e.validTo)-(new Date).getTime()/1e3;(r=t/60/60/24)<5?logger.logger.error(r+" days left"):r<10?logger.logger.warn(r+" days left"):logger.logger.info(r+" days left")}null!=e.uniqueLicenseId&&""!=e.uniqueLicenseId&&(n=e.uniqueLicenseId)});var t=os.networkInterfaces(),o=[];Object.keys(t).forEach(function(e){var n=0;t[e].forEach(function(r){"IPv4"===r.family&&!1===r.internal&&(n>=1?o.push({name:e+":"+n,address:r.address}):o.push({name:e,address:r.address}),++n)})}),request({url:"http://bigdotsoftware.pl/inviteposnetserver.php",method:"POST",rejectUnauthorized:!1,strictSSL:!1,json:{action:"license",days:r,uniqueLicenseId:n,hostname:os.hostname(),platform:os.platform(),arch:os.arch(),uptime:os.uptime(),type:os.type(),ifacesarray:o}},(e,n,r)=>{e?logger.logger.info("cannot execute invitation: "+e):logger.logger.info("executed ok")}),""!=n&&r<10&&(logger.logger.info("Obtaining new license file"),obtainNewLicenseFile(n))}return e}module.exports.init=init;